#ifndef EFL_TEXT_FORMAT_EO_HH
#define EFL_TEXT_FORMAT_EO_HH
#include <Eo.h>

extern "C" {
#include "efl_text_format.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace efl { namespace text { 
struct Format;
} } 
namespace efl { namespace eo { template<> struct is_eolian_object< ::efl::text::Format> : ::std::true_type {}; } }
namespace efl { namespace text { 
struct Format;
} } 

namespace eo_cxx {
namespace efl { namespace text { 
struct Format {
   ::efl::eolian::return_traits<double>::type ellipsis_get() const;
   ::efl::eolian::return_traits<void>::type ellipsis_set( ::efl::eolian::in_traits<double>::type value) const;
   ::efl::eolian::return_traits<Efl_Text_Format_Wrap>::type wrap_get() const;
   ::efl::eolian::return_traits<void>::type wrap_set( ::efl::eolian::in_traits<Efl_Text_Format_Wrap>::type wrap) const;
   ::efl::eolian::return_traits<bool>::type multiline_get() const;
   ::efl::eolian::return_traits<void>::type multiline_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits<Efl_Text_Format_Horizontal_Alignment_Type>::type halign_get() const;
   ::efl::eolian::return_traits<void>::type halign_set( ::efl::eolian::in_traits<Efl_Text_Format_Horizontal_Alignment_Type>::type value) const;
   ::efl::eolian::return_traits<Efl_Text_Format_Vertical_Alignment_Type>::type valign_get() const;
   ::efl::eolian::return_traits<void>::type valign_set( ::efl::eolian::in_traits<Efl_Text_Format_Vertical_Alignment_Type>::type value) const;
   ::efl::eolian::return_traits<double>::type linegap_get() const;
   ::efl::eolian::return_traits<void>::type linegap_set( ::efl::eolian::in_traits<double>::type value) const;
   ::efl::eolian::return_traits<double>::type linerelgap_get() const;
   ::efl::eolian::return_traits<void>::type linerelgap_set( ::efl::eolian::in_traits<double>::type value) const;
   ::efl::eolian::return_traits<int>::type tabstops_get() const;
   ::efl::eolian::return_traits<void>::type tabstops_set( ::efl::eolian::in_traits<int>::type value) const;
   ::efl::eolian::return_traits<bool>::type password_get() const;
   ::efl::eolian::return_traits<void>::type password_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type replacement_char_get() const;
   ::efl::eolian::return_traits<void>::type replacement_char_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type repch) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_TEXT_FORMAT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::efl::text::Format() const;
   operator ::efl::text::Format&();
   operator ::efl::text::Format const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Format> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Format const > operator&() const { return {this}; }
   /// @endcond
};
} } 
}
namespace efl { namespace text { 
struct Format : ::efl::eo::concrete
{
   explicit Format( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Format(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Format(Format const& other) = default;
   Format(Format&& other) = default;
   Format& operator=(Format const& other) = default;
   Format& operator=(Format&& other) = default;
   Format()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Format( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Format(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   ::efl::eolian::return_traits<double>::type ellipsis_get() const;
   ::efl::eolian::return_traits<void>::type ellipsis_set( ::efl::eolian::in_traits<double>::type value) const;
   ::efl::eolian::return_traits<Efl_Text_Format_Wrap>::type wrap_get() const;
   ::efl::eolian::return_traits<void>::type wrap_set( ::efl::eolian::in_traits<Efl_Text_Format_Wrap>::type wrap) const;
   ::efl::eolian::return_traits<bool>::type multiline_get() const;
   ::efl::eolian::return_traits<void>::type multiline_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits<Efl_Text_Format_Horizontal_Alignment_Type>::type halign_get() const;
   ::efl::eolian::return_traits<void>::type halign_set( ::efl::eolian::in_traits<Efl_Text_Format_Horizontal_Alignment_Type>::type value) const;
   ::efl::eolian::return_traits<Efl_Text_Format_Vertical_Alignment_Type>::type valign_get() const;
   ::efl::eolian::return_traits<void>::type valign_set( ::efl::eolian::in_traits<Efl_Text_Format_Vertical_Alignment_Type>::type value) const;
   ::efl::eolian::return_traits<double>::type linegap_get() const;
   ::efl::eolian::return_traits<void>::type linegap_set( ::efl::eolian::in_traits<double>::type value) const;
   ::efl::eolian::return_traits<double>::type linerelgap_get() const;
   ::efl::eolian::return_traits<void>::type linerelgap_set( ::efl::eolian::in_traits<double>::type value) const;
   ::efl::eolian::return_traits<int>::type tabstops_get() const;
   ::efl::eolian::return_traits<void>::type tabstops_set( ::efl::eolian::in_traits<int>::type value) const;
   ::efl::eolian::return_traits<bool>::type password_get() const;
   ::efl::eolian::return_traits<void>::type password_set( ::efl::eolian::in_traits<bool>::type enabled) const;
   ::efl::eolian::return_traits< ::efl::eina::string_view>::type replacement_char_get() const;
   ::efl::eolian::return_traits<void>::type replacement_char_set( ::efl::eolian::in_traits< ::efl::eina::string_view>::type repch) const;
   static Efl_Class const* _eo_class()
   {
      return EFL_TEXT_FORMAT_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Format> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Format const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Format) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Format>::value, "");
} } 
#endif
